/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.aspectj.weaver.ast.Not;
import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.estate.entity.Notice;
import org.springblade.estate.service.INoticeService;
import org.springblade.estate.vo.NoticeVO;
import org.springblade.estate.wrapper.NoticeWrapper;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.estate.entity.NoticePushRecord;
import org.springblade.estate.vo.NoticePushRecordVO;
import org.springblade.estate.wrapper.NoticePushRecordWrapper;
import org.springblade.estate.service.INoticePushRecordService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.stream.Collectors;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-04-29
 */
@RestController
@AllArgsConstructor
@RequestMapping("/noticepushrecord")
@Api(value = "", tags = "接口")
public class NoticePushRecordController extends BladeController {

	private final INoticePushRecordService noticePushRecordService;
	private final INoticeService noticeService;
	private final IOrgPositionClient orgPositionClient;
	private final IResidentialClient residentialClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入noticePushRecord")
	public R<NoticePushRecordVO> detail(NoticePushRecord noticePushRecord) {
		NoticePushRecord detail = noticePushRecordService.getOne(Condition.getQueryWrapper(noticePushRecord));
		return R.data(NoticePushRecordWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入noticePushRecord")
	public R<IPage<NoticePushRecordVO>> list(NoticePushRecord noticePushRecord, Query query) {
		IPage<NoticePushRecord> pages = noticePushRecordService.page(Condition.getPage(query), Condition.getQueryWrapper(noticePushRecord));
		return R.data(NoticePushRecordWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入noticePushRecord")
	public R<IPage<NoticePushRecordVO>> page(NoticePushRecordVO noticePushRecord, Query query) {
		IPage<NoticePushRecordVO> pages = noticePushRecordService.selectNoticePushRecordPage(Condition.getPage(query), noticePushRecord);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入noticePushRecord")
	public R save(@Valid @RequestBody NoticePushRecord noticePushRecord) {
		return R.status(noticePushRecordService.save(noticePushRecord));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入noticePushRecord")
	public R update(@Valid @RequestBody NoticePushRecord noticePushRecord) {
		return R.status(noticePushRecordService.updateById(noticePushRecord));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入noticePushRecord")
	public R submit(@Valid @RequestBody NoticePushRecord noticePushRecord) {
		Long residentialId = noticePushRecord.getResidentialId();
		Residential residential = residentialClient.getById(residentialId);
		Assert.notNull(residential, "发布对象不存在");
		noticePushRecord.setAgencyName(residential.getAgencyName());
		noticePushRecord.setResidentialName(residential.getName());
		noticePushRecordService.deleteByCondition(null, noticePushRecord.getNoticeId(), noticePushRecord.getAgencyId(), noticePushRecord.getResidentialId());
		return R.status(noticePushRecordService.saveOrUpdate(noticePushRecord));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		List<Long> idList = Func.toLongList(ids);
		for(Long id : idList){
			noticePushRecordService.deleteByCondition(id, null, null, null);
		}
		return R.status(true);
	}


	/**
	 * 根据下发记录返回公告列表
	 */
	@GetMapping("/listReturnNotice")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入noticePushRecord")
	public R<IPage<NoticeVO>> listReturnNotice(NoticePushRecord noticePushRecord, Query query) {
		LambdaQueryWrapper<NoticePushRecord> queryWrapper = new QueryWrapperUtil<NoticePushRecord>().getBasicQueryWrapper(
			NoticePushRecord::getOrgPosition, noticePushRecord, AuthUtil.getUser(), orgPositionClient
		);
		IPage<NoticePushRecord> pages = noticePushRecordService.page(Condition.getPage(query), queryWrapper.eq(NoticePushRecord::getTenantId,AuthUtil.getUser().getTenantId()));
		IPage<Notice> resultPage = new Page<>();
		resultPage.setTotal(pages.getTotal());
		resultPage.setCurrent(pages.getCurrent());
		resultPage.setSize(pages.getSize());
		List<Long> noticeIds = pages.getRecords().stream().map(NoticePushRecord::getNoticeId).collect(Collectors.toList());
		if(noticeIds.size() > 0){
			List<Notice> records = noticeService.getBaseMapper().selectList(new QueryWrapper<>(new Notice()).lambda()
				.in(Notice::getId, noticeIds));
			resultPage.setRecords(records);
		}


		return R.data(NoticeWrapper.build().pageVO(resultPage));
	}


}
